var vows=require("vows"),request=require("request"),assert=require("assert"),static=require("../../lib/node-static"),fileServer=new static.Server(__dirname+"/../fixtures"),suite=vows.describe("node-static"),TEST_PORT=8080,TEST_SERVER="http://localhost:"+TEST_PORT,version=static.version.join("."),server,callback;headers={"requesting headers":{topic:function(){request.head(TEST_SERVER+"/index.html",this.callback)}}};headers["requesting headers"]["should respond with node-static/"+version]=function(t,e){assert.equal(e.headers.server,"node-static/"+version)};suite.addBatch({"once an http server is listening with a callback":{topic:function(){server=require("http").createServer(function(t,e){fileServer.serve(t,e,function(s,i){callback?callback(t,e,s,i):t.end()})}).listen(TEST_PORT,this.callback)},"should be listening":function(){assert.isTrue(!0)}}}).addBatch({"streaming a 404 page":{topic:function(){callback=function(t,e,s){if(s){e.writeHead(s.status,s.headers);setTimeout(function(){e.end("Custom 404 Stream.")},100)}};request.get(TEST_SERVER+"/not-found",this.callback)},"should respond with 404":function(t,e){assert.equal(e.statusCode,404)},"should respond with the streamed content":function(t,e,s){callback=null;assert.equal(s,"Custom 404 Stream.")}}}).addBatch({"once an http server is listening without a callback":{topic:function(){server.close();server=require("http").createServer(function(t,e){fileServer.serve(t,e)}).listen(TEST_PORT,this.callback)},"should be listening":function(){assert.isTrue(!0)}}}).addBatch({"requesting a file not found":{topic:function(){request.get(TEST_SERVER+"/not-found",this.callback)},"should respond with 404":function(t,e){assert.equal(e.statusCode,404)}}}).addBatch({"requesting a malformed URI":{topic:function(){request.get(TEST_SERVER+"/a%AFc",this.callback)},"should respond with 400":function(t,e){assert.equal(e.statusCode,400)}}}).addBatch({"serving hello.txt":{topic:function(){request.get(TEST_SERVER+"/hello.txt",this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"should respond with text/plain":function(t,e){assert.equal(e.headers["content-type"],"text/plain")},"should respond with hello world":function(t,e,s){assert.equal(s,"hello world")}}}).addBatch({"serving directory index":{topic:function(){request.get(TEST_SERVER,this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"should respond with text/html":function(t,e){assert.equal(e.headers["content-type"],"text/html")}}}).addBatch({"serving index.html from the cache":{topic:function(){request.get(TEST_SERVER+"/index.html",this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"should respond with text/html":function(t,e){assert.equal(e.headers["content-type"],"text/html")}}}).addBatch({"requesting with If-None-Match":{topic:function(){var t=this;request.get(TEST_SERVER+"/index.html",function(e,s){request({method:"GET",uri:TEST_SERVER+"/index.html",headers:{"if-none-match":s.headers.etag}},t.callback)})},"should respond with 304":function(t,e){assert.equal(e.statusCode,304)}},"requesting with If-None-Match and If-Modified-Since":{topic:function(){var t=this;request.get(TEST_SERVER+"/index.html",function(e,s){var i=Date.parse(s.headers["last-modified"]),a=new Date(i+864e5).toUTCString(),n="1111222233334444";request({method:"GET",uri:TEST_SERVER+"/index.html",headers:{"if-none-match":n,"if-modified-since":a}},t.callback)})},"should respond with a 200":function(t,e){assert.equal(e.statusCode,200)}}}).addBatch({"requesting POST":{topic:function(){request.post(TEST_SERVER+"/index.html",this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"should not be empty":function(t,e,s){assert.isNotEmpty(s)}}}).addBatch({"requesting HEAD":{topic:function(){request.head(TEST_SERVER+"/index.html",this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"head must has no body":function(t,e,s){assert.isEmpty(s)}}}).addBatch(headers).addBatch({"addings custom mime types":{topic:function(){static.mime.define({"application/font-woff":["woff"]});this.callback()},"should add woff":function(){assert.equal(static.mime.lookup("woff"),"application/font-woff")}}}).addBatch({"serving subdirectory index":{topic:function(){request.get(TEST_SERVER+"/there/",this.callback)},"should respond with 200":function(t,e){assert.equal(e.statusCode,200)},"should respond with text/html":function(t,e){assert.equal(e.headers["content-type"],"text/html")}}}).addBatch({"redirecting to subdirectory index":{topic:function(){request.get({url:TEST_SERVER+"/there",followRedirect:!1},this.callback)},"should respond with 301":function(t,e){assert.equal(e.statusCode,301)},"should respond with location header":function(t,e){assert.equal(e.headers.location,"/there/")},"should respond with empty string body":function(t,e,s){assert.equal(s,"")}}}).addBatch({"requesting a subdirectory (with trailing slash) not found":{topic:function(){request.get(TEST_SERVER+"/notthere/",this.callback)},"should respond with 404":function(t,e){assert.equal(e.statusCode,404)}}}).addBatch({"requesting a subdirectory (without trailing slash) not found":{topic:function(){request.get({url:TEST_SERVER+"/notthere",followRedirect:!1},this.callback)},"should respond with 404":function(t,e){assert.equal(e.statusCode,404)}}})["export"](module);